{univerzalna graficka unita... este neni hotova... chybaju paletove funkcie...}
Unit UniGr;


INTERFACE

Type
  NScreen = Array [0..64000-1] of Byte;
  PScreen = ^NScreen;
  NArray = Array [0..16385] of Word;
  PArray = ^NArray;
  PaletteTp = Array [0..256*3-1] Of Byte;

Var
  Screen : PScreen;

  Procedure SetGraph;
  Procedure SetText;


  Function  GetPixel(PScr : PScreen; X, Y: Integer) : Byte;
  Procedure PutPixel(PScr : PScreen; X, Y: Integer; C : Byte);
  Function  ImageSize(X1, Y1, X2, Y2 : Integer) : Integer;
  Procedure InitPicture(var P : Pointer; X1, Y1, X2, Y2 : Integer);

  Procedure SetRes(P : PArray; X1, Y1, X2, Y2 : Integer);
  Procedure InitScreen(var P : PScreen);
  Procedure GetImg(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Procedure PutImg(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Procedure PutImgNull(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Procedure Blit(PScr : Pointer; What : Pointer);
  Procedure Clear(PScr : Pointer);
  Procedure Clear_To(PScr : Pointer; Color : Byte);
  Procedure Line(PScr : PScreen; X1, Y1, X2, Y2 : Longint; C : Integer);
  Procedure V_Sync;
  Procedure Blit2(Done, Map1, Map2 : PScreen; Sub : Integer);
  Function  GetPixel2(PScr1, PScr2 : PScreen; X, Y: Integer) : Byte;
  Procedure PutPixel2(PScr1, PScr2 : PScreen; X, Y: Integer; C : Byte);
  Procedure PutImg2(PScr1, PScr2 : Pointer; X1, Y1 : Word; Ptr : PArray);
  Procedure PutImgNull2(PScr1, PScr2 : Pointer; X1, Y1 : Word; Ptr : PArray);
  Procedure Line2(PScr1, PScr2 : PScreen; X1, Y1, X2, Y2 : Integer; C : Integer);
  Procedure Rect(PScr : Pointer; X1, Y1, X2, Y2 : Integer; C : Integer);
  Procedure DrawPCX(Scrn : Pointer; Name: String; XSub, YSub : Word; var RGB_Palette : Array of Byte);
  Procedure SetPal(Pal : PaletteTp);
  Procedure SetRGB(C, R, G, B : Byte);

  Procedure GetImg_hflip(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Procedure GetImg_vflip(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Procedure GetImg_hvflip(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Procedure FillTexture32Ofs(PScr : Pointer; Ptr : PArray; OffX, OffY : Integer);

  Procedure PutImg16(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Procedure PutImgNull16(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Procedure FillTexture16(PScr : Pointer; Ptr : PArray);
  Procedure FillTexture16Ofs(PScr : Pointer; Ptr : PArray; OffX, OffY : Integer);

IMPLEMENTATION

  {$I PCX.INC}

  Procedure SetRGB(C, R, G, B : Byte);
  Begin
    Asm
	    MOV		DX,$03C8
	    MOV		AL,[C]
	    OUT		DX,AL
	    INC		DX
	    MOV		AL,[R]
	    OUT		DX,AL
	    MOV		AL,[G]
	    OUT		DX,AL
	    MOV		AL,[B]
	    OUT		DX,AL
    End;
  end;

  Procedure SetPal(Pal : PaletteTp);
  Var I : Integer;
  Begin
    For I := 0 to 255 do
      SetRGB(I, Pal[I*3], Pal[I*3+1], Pal[I*3+2]);
  End;
  Procedure SetGraph; Assembler;
  Asm
    Mov AX, 013h
    Int 010h
  End;
  Procedure SetText; Assembler;
  Asm
    Mov AX, 003h
    Int 010h
  End;

  Procedure InitScreen(var P : PScreen);
  Begin
    GetMem(P, 64000);
  End;
  Procedure Clear(PScr : Pointer);
  Begin
    fillchar(PScr^, 64000, 0);
  End;
  Procedure Clear_To(PScr : Pointer; Color : Byte);
  Begin
    fillchar(PScr^, 64000, Color);
  End;

  Procedure Line(PScr : PScreen; X1, Y1, X2, Y2 : Longint; C : Integer);
  Var Cnt, I : Integer;

  Begin
    if Abs(X1-X2) > Abs(Y1-Y2) then
      Cnt := Abs(X1-X2)
    Else
      Cnt := Abs(Y1-Y2);
    For I := 0 to Cnt do
      PutPixel(PScr, X1 + (X2-X1)*I div Cnt,
                     Y1 + (Y2-Y1)*I div Cnt, C);
  End;
  Procedure Rect(PScr : Pointer; X1, Y1, X2, Y2 : Integer; C : Integer);
  Begin
    Line(PScr, X1, Y1, X2, Y1, C);
    Line(PScr, X1, Y1, X1, Y2, C);
    Line(PScr, X1, Y2, X2, Y2, C);
    Line(PScr, X2, Y1, X2, Y2, C);
  End;
  Procedure Line2(PScr1, PScr2 : PScreen; X1, Y1, X2, Y2 : Integer; C : Integer);
  Var Cnt, I : Integer;

  Begin
    if Abs(X1-X2) > Abs(Y1-Y2) then
      Cnt := Abs(X1-X2)
    Else
      Cnt := Abs(Y1-Y2);
    For I := 0 to Cnt do
      PutPixel2(PScr1, PScr2, X1 + (X2-X1)*I div Cnt,
                     Y1 + (Y2-Y1)*I div Cnt, C);
  End;

  Function GetPixel(PScr : PScreen; X, Y: Integer) : Byte;
  Begin
    if (X >= 0) and (Y >= 0) and (X < 320) and (Y < 200) then
      GetPixel := PScr^[Y*320+X]
    Else
      GetPixel := 0;
  End;
  Procedure PutPixel(PScr : PScreen; X, Y: Integer; C : Byte);
  Begin
    if (X >= 0) and (Y >= 0) and (X < 320) and (Y < 200) then
      PScr^[Y*320+X] := C;
  End;
  Function ImageSize(X1, Y1, X2, Y2 : Integer) : Integer;
  Begin
    if ((X2-X1) > 128) or
       ((Y2-Y1) > 128) Then Halt(1); {mem error}
    ImageSize := abs((X2-X1)*(Y2-Y1))+2; {Jeden nikdy nevie...}
  End;
  Procedure InitPicture(var P : Pointer; X1, Y1, X2, Y2 : Integer);
  Begin
    {maximalne obrazky 128x128}
    GetMem(P, ImageSize(X1, Y1, X2+16, Y2+16));
  End;
  Procedure SetRes(P : PArray; X1, Y1, X2, Y2 : Integer);
  Begin
    P^[0] := X2-X1;
    P^[1] := Y2-Y1;
  End;
  {Zoberie obrazok do pamate}
  Procedure GetImg(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Var X, Y, I : Word;
  Begin
    Ptr^[0] := X2-X1;
    Ptr^[1] := Y2-Y1;
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      Ptr^[I+2] := GetPixel(PScr, X1 + I mod Ptr^[0], Y1 + I div Ptr^[0]);
  End;
  Procedure GetImg_hflip(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Var X, Y, I, Siz : Word;
  Begin
    Ptr^[0] := X2-X1;
    Ptr^[1] := Y2-Y1;
    Siz := X2-X1;
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      Ptr^[I+2] := GetPixel(PScr, X1 + Siz-(I mod Ptr^[0])-1, Y1 + I div Ptr^[0]);
  End;
  Procedure GetImg_vflip(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Var X, Y, I, Siz : Word;
  Begin
    Ptr^[0] := X2-X1;
    Ptr^[1] := Y2-Y1;
    Siz := Y2-Y1;
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      Ptr^[I+2] := GetPixel(PScr, X1 + I mod Ptr^[0], Y1 + Siz-(I div Ptr^[0])-1);
  End;
  Procedure GetImg_hvflip(PScr : Pointer; X1, Y1, X2, Y2 : Word; Ptr : PArray);
  Var X, Y, I, Siz1, Siz2 : Word;
  Begin
    Ptr^[0] := X2-X1;
    Ptr^[1] := Y2-Y1;
    Siz1 := X2-X1;
    Siz2 := Y2-Y1;
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      Ptr^[I+2] := GetPixel(PScr, X1 + Siz1-(I mod Ptr^[0])-1, Y1 + Siz2-(I div Ptr^[0])-1);
  End;

  {Nakresli obrazok z pamate}
  Procedure PutImg(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Var X, Y, I : Word;
  Begin
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      PutPixel(PScr, X1+(I mod Ptr^[0]),
               Y1+(I div Ptr^[0]), Ptr^[I+2]);
  End;
  Procedure PutImg16(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Var X, Y, I : Word;
  Begin
    For I := 0 to 255 do
      PutPixel(PScr, X1+(I And 15),
               Y1+(I shr 4), Ptr^[I+2]);
  End;

  Procedure PutImg2(PScr1, PScr2 : Pointer; X1, Y1 : Word; Ptr : PArray);
  Var X, Y, I : Word;
  Begin
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      PutPixel2(PScr1, PScr2, X1+(I mod Ptr^[0]),
               Y1+(I div Ptr^[0]), Ptr^[I+2]);
  End;
  Procedure PutImgNull2(PScr1, PScr2 : Pointer; X1, Y1 : Word; Ptr : PArray);
  Var X, Y, I : Word;
  Begin
    If Ptr^[0]*Ptr^[1] = 0 then Halt;
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      If Ptr^[I+2] <> 0 then
        PutPixel2(PScr1, PScr2, X1+(I mod Ptr^[0]),
                 Y1+(I div Ptr^[0]), Ptr^[I+2]);
  End;

  {To iste, len ak bod na obrazku = 2, nevykresli ho
   (cierna farba je teda priesvitna)}
  Procedure PutImgNull(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Var X, Y, I : Word;
  Begin
    If Ptr^[0]*Ptr^[1] = 0 then Halt;
    For I := 0 to Ptr^[0]*Ptr^[1]-1 do
      If Ptr^[I+2] <> 0 then
        PutPixel(PScr, X1+(I mod Ptr^[0]),
                 Y1+(I div Ptr^[0]), Ptr^[I+2]);
  End;
  Procedure PutImgNull16(PScr : Pointer; X1, Y1 : Word; Ptr : PArray);
  Var X, Y, I : Word;
  Begin
    For I := 0 to 255 do
      If Ptr^[I+2] <> 0 then
        PutPixel(PScr, X1+(I and 15),
                 Y1+(I shr 4), Ptr^[I+2]);
  End;

  Procedure Blit(PScr : Pointer; What : Pointer);
  Begin
    Move(What^, PScr^, 64000);
  End;
  Procedure Blit2(Done, Map1, Map2 : PScreen; Sub : Integer);
  Var I : Integer;
  Begin
    For I := 0 to 200-1 Do
    Begin
      Move(Map1^[I*320+Sub], Done^[I*320+0],   320-Sub);
      Move(Map2^[I*320],     Done^[I*320+320-Sub], Sub);
    End;
  End;
  Function GetPixel2(PScr1, PScr2 : PScreen; X, Y: Integer) : Byte;
  Begin
    if (X >= 0) and (Y >= 0) and (X < 320) and (Y < 200) then
      GetPixel2 := PScr1^[Y*320+X] else
    If (X >= 320) and (Y >= 0) and (X < 640) and (Y < 200) then
      GetPixel2 := PScr2^[Y*320+X-320] else
      GetPixel2 := 0;
  End;
  Procedure PutPixel2(PScr1, PScr2 : PScreen; X, Y: Integer; C : Byte);
  Begin
    if (X >= 0) and (Y >= 0) and (X < 320) and (Y < 200) then
      PScr1^[Y*320+X] := C;
    If (X >= 320) and (Y >= 0) and (X < 640) and (Y < 200) then
      PScr2^[Y*320+X-320] := C;
  End;

Procedure FillTexture16(PScr : Pointer; Ptr : PArray);
  Var I : Word;
  Begin
    For I := 0 to $F9FF do
      PScreen(PScr)^[I] := Ptr^[I and 15 + ((I shr 8) and 15)*16+2];
  End;
Procedure FillTexture16Ofs(PScr : Pointer; Ptr : PArray; OffX, OffY : Integer);
  Var I : Word;
  Begin
    For I := 0 to $F9FF do
      PScreen(PScr)^[I] := Ptr^[(I+OffX) and 15 + ((OffY+I shr 8) and 15)*16+2];
  End;
Procedure FillTexture32Ofs(PScr : Pointer; Ptr : PArray; OffX, OffY : Integer);
  Var I : Word;
  Begin
    For I := 0 to $F9FF do
      PScreen(PScr)^[I] := Ptr^[(I+OffX) and 31 + (((OffY+I div 320) and 31)*32+2)];
  End;

{Tieto procedury patria este ku grafickemu driveru}

procedure V_Sync; assembler;
asm
  mov  dx, 3dah
@1:
  in   al, dx
  test al, 8
  jz   @1
@2:
  in   al, dx
  test al, 8
  jnz  @2
end;


Begin
  Screen := @MEM[$A000:0000]; {inicializuj Screen ako videopamat}
  WriteLn('UniGraph unita inicializovana. Unit made by gabonator@Atlas.cz');
End.